#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u1-2

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"


PASSED_MSG="OK"
NUMBER_OF_STEPS=1
CURRENT_STEP=0
PASSED_STEPS=0


#PRIPRAVA SUBOROV
echo "PRÍPRAVA"
mkdir dir1
echo "PRÍPRAVA - OK"

echo
echo "Testovanie ulohy u1_2 z cvicenia 2"
echo


#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e openat -o $STRACE_OUTPUT ./$TESTED_PROGRAM dir1/file2 > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test(){
((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby open()"
if grep -q "^openat(AT_FDCWD, \"dir1/file2\", O_RDWR|O_CREAT, 0777)" $STRACE_OUTPUT; then
	echo "OK - Sluzba open() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba open() nebola zavolana alebo jej boli zadane nespravne parametre."
	return 1
fi
}

#ZAVOLANIE TESTU
test

#MAZANIE VYTVORENYCH SUBOROV
echo
echo "MAZANIE POMOCNYCH SUBOROV"
rm dir1/file2
rmdir dir1
echo "MAZANIE POMOCNYCH SUBOROV - OK"


#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."

if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		echo
		echo "Zaznamy o teste su ulozene v suboroch:"
		echo "$STRACE_OUTPUT"
		echo "$TESTED_PROGRAM_OUTPUT"
fi