#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u2-2

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"

NUMBER_OF_STEPS=4
CURRENT_STEP=0
PASSED_STEPS=0

#PRIPRAVA SUBOROV
echo "PRÍPRAVA"
echo -n 123456789 > file6.txt
echo -n 12345678912 > expected_content.txt
echo "PRÍPRAVA - OK"

echo
echo "Testovanie ulohy u2_2 z cvicenia 2"
echo

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e openat,read,write -o $STRACE_OUTPUT ./$TESTED_PROGRAM > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test(){

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby open()"
if grep -q "^openat(AT_FDCWD, \"file6.txt\", O_RDWR|O_APPEND)" $STRACE_OUTPUT; then
	echo "OK - Sluzba open() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba open() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby read()"
if grep -q -e "^read(., \"12\", 2)" $STRACE_OUTPUT; then
	echo "OK - Sluzba read() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1)) 
else	
	echo "CHYBA - Sluzba read() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby write()"
if grep -q -e "^write(., \"12\", 2)" $STRACE_OUTPUT; then
	echo "OK - Sluzba write() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1)) 
else	
	echo "CHYBA - Sluzba write() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie spravnosti obsahu suboru file6.txt"
if diff file6.txt expected_content.txt; then
	echo "OK - Subor file6.txt ma ocakavany obsah."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Obsah suboru file6.txt nezodpoveda ocakavanemu obsahu."
	return 1
fi
}

#ZAVOLANIE TESTU
test

#MAZANIE VYTVORENYCH SUBOROV
echo
echo "MAZANIE POMOCNYCH SUBOROV"
rm file6.txt
rm expected_content.txt
echo "MAZANIE POMOCNYCH SUBOROV - OK"

#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."

if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		echo
		echo "Zaznamy o teste su ulozene v suboroch:"
		echo "$STRACE_OUTPUT"
		echo "$TESTED_PROGRAM_OUTPUT"
fi


