#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u3-1

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"

NUMBER_OF_STEPS=4
CURRENT_STEP=0
PASSED_STEPS=0

#PRIPRAVA SUBOROV
echo "PRÍPRAVA"
echo "Operacne  ystemy"  > nazov.txt
echo "Operacne systemy" > expected_content.txt
echo "PRÍPRAVA - OK"

echo
echo "Testovanie ulohy u3_1 z cvicenia 2"
echo

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e openat,lseek,write -o $STRACE_OUTPUT ./$TESTED_PROGRAM > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test(){

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby open()" 
if grep -E -q "^openat\(AT_FDCWD, \"nazov.txt\", (O_RDWR|O_WRONLY)\)" $STRACE_OUTPUT; then
	echo "OK - Sluzba open() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba open() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby lseek()"
if grep -q -e "^lseek(., 9, SEEK_SET)" $STRACE_OUTPUT; then
	echo "OK - Sluzba lseek() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba lseek() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby write()"
if grep -q -e "^write(., \"s\", 1)" $STRACE_OUTPUT; then
	echo "OK - Sluzba write() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1)) 
else	
	echo "CHYBA - Sluzba write() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie spravnosti obsahu suboru nazov.txt"
if diff nazov.txt expected_content.txt; then
	echo "OK - Subor nazov.txt ma ocakavany obsah."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Obsah suboru nazov.txt nezodpoveda ocakavanemu obsahu."
	return 1
fi
}

#ZAVOLANIE TESTU
test

#MAZANIE VYTVORENYCH SUBOROV
echo
echo "MAZANIE POMOCNYCH SUBOROV"
rm nazov.txt
rm expected_content.txt
echo "MAZANIE POMOCNYCH SUBOROV - OK"


#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."

if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		echo
		echo "Zaznamy o teste su ulozene v suboroch:"
		echo "$STRACE_OUTPUT"
		echo "$TESTED_PROGRAM_OUTPUT"
fi

