#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u4-1

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"


NUMBER_OF_STEPS=3
CURRENT_STEP=0
PASSED_STEPS=0

#PRIPRAVA SUBOROV
echo "PRÍPRAVA"
echo -n 1234 > lseek3.txt
echo -n -e '1234\0\0\0\0\0\0\0\0\0\0ab' > expected_content.txt
echo "PRÍPRAVA - OK"

echo
echo "Testovanie ulohy u4_1 z cvicenia 2"
echo

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e lseek,write -o $STRACE_OUTPUT ./$TESTED_PROGRAM > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test(){

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby lseek()"
if grep -q -e "^lseek(., 10, SEEK_END)" $STRACE_OUTPUT; then
	echo "OK - Sluzba lseek() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba lseek() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS"
if grep -q -e "^write(., \"ab\", 2)" $STRACE_OUTPUT; then
	echo "OK - Sluzba write() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1)) 
else	
	echo "CHYBA - Sluzba write() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie spravnosti obsahu suboru lseek3.txt"
if diff lseek3.txt expected_content.txt; then
	echo "OK - Subor lseek3.txt ma ocakavany obsah."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Obsah suboru lseek.txt nezodpoveda ocakavanemu obsahu."
	return 1
fi
}

#ZAVOLANIE TESTU
test

#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."
echo

if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		echo
		echo "Zaznamy o teste su ulozene v suboroch:"
		echo "$STRACE_OUTPUT"
		echo "$TESTED_PROGRAM_OUTPUT"
		echo
fi

#MAZANIE VYTVORENYCH SUBOROV
echo
echo "MAZANIE POMOCNYCH SUBOROV"
rm lseek3.txt
rm expected_content.txt
echo "MAZANIE POMOCNYCH SUBOROV - OK"
